/**
 * @file   MPI.cpp
 * @author Ruo Li <rli@aztec>
 * @date   Sat Oct  3 20:48:26 2009
 * 
 * @brief  
 * 
 * 
 */

#include <cstdlib>
#include <mpi.h>

namespace MPI {

  int get_random_tag(MPI_Comm comm) {
    int rank, tag;
    MPI_Comm_rank(comm, &rank);
    if (rank == 0) {
      tag = rand();
      if (tag < RAND_MAX/2) {
        tag = RAND_MAX - tag;
      }
#if MPI_VERSION == 1 /// mpich 版本为 1，不支持大 tag
      tag %= 1024;
#endif
    }
    MPI_Bcast(&tag, 1, MPI_INT, 0, comm);
    
    return tag;
  }

}

/**
 * end of file
 * 
 */
